.586
.model flat,stdcall
option casemap:none

WinMain	PROTO	:DWORD,:DWORD,:DWORD,:DWORD
AddString	PROTO	:DWORD,:DWORD

include d:\masm32\include\windows.inc
include d:\masm32\include\user32.inc
include d:\masm32\include\kernel32.inc
include d:\masm32\include\gdi32.inc
include d:\masm32\include\comctl32.inc
include d:\masm32\include\shell32.inc

includelib d:\masm32\lib\kernel32.lib
includelib d:\masm32\lib\user32.lib
includelib d:\masm32\lib\gdi32.lib
includelib d:\masm32\lib\comctl32.lib
includelib d:\masm32\lib\shell32.lib

.const

MainWindowWidth		equ		300
MainWindowHeight		equ		300

.data
	
hInstance			dd		?
hMainWindow		dd		?
MainWindowClass	db		'MainWindowClass',0
MainWindowName	db		'Custom Draw TreeView Example',0
wc			WNDCLASSEX		<sizeof wc,CS_HREDRAW+CS_VREDRAW,offset WndProc,NULL,NULL,\
							?,?,?,COLOR_WINDOW,NULL,offset MainWindowClass,?>
							
; ++++ Tree View related ++++

hTreeView		dd		?
TreeViewClass	db		'SysTreeView32',0
tvis			TV_INSERTSTRUCT		<>
tvi			TV_ITEM					<>

; ++++ Other Vars	++++

rect			RECT		<>
szSpec		db			'c:\*',0,252 dup(0)
szDirectory	db			'c:\users',0	
Buffer		db			256	dup(0)		
hList			dd			0
hFind		dd			?
w32fd		WIN32_FIND_DATA		<>	
shfi			SHFILEINFO			<>		
szTahoma	db			'Tahoma',0
szUnselArrow	db			'.\unsel.bmp',0
szSelArrow	db			'.\sel.bmp',0
hUnselArrow	dd			?
hSelArrow	dd			?
hMemDC		HDC			?
							
.code
	start:
		invoke	GetModuleHandle,NULL
		mov		hInstance,eax
		invoke	WinMain,hInstance,NULL,NULL,NULL
		invoke	ExitProcess,eax
		
WinMain	PROC	hInst:DWORD,hPInst:DWORD,CmdLine:DWORD,CmdShow:DWORD
	
		local		msg:MSG
		
		push		hInst
		pop		wc.hInstance
		invoke	LoadIcon,NULL,IDI_APPLICATION
		mov		wc.hIcon,eax
		mov		wc.hIconSm,eax
		invoke	LoadCursor,NULL,IDC_ARROW
		mov		wc.hCursor,eax
		invoke	RegisterClassEx,addr wc
		invoke	GetSystemMetrics,SM_CYSCREEN
		shr		eax,1
		sub		eax,MainWindowHeight/2
		push		eax
		invoke	GetSystemMetrics,SM_CXSCREEN
		shr		eax,1
		sub		eax,MainWindowWidth/2
		pop		ebx
		invoke	CreateWindowEx,NULL,addr MainWindowClass,addr MainWindowName,WS_TILED,\
				eax,ebx,MainWindowWidth,MainWindowHeight,NULL,NULL,hInst,NULL
		mov		hMainWindow,eax
		invoke	ShowWindow,eax,SW_SHOWNORMAL
		invoke	UpdateWindow,hMainWindow
		
msg_loop:
		invoke	GetMessage,addr msg,NULL,0,0
		or		eax,eax
		jz		end_msgloop
		invoke	TranslateMessage,addr msg
		invoke	DispatchMessage,addr msg
		jmp		msg_loop
end_msgloop:
		mov		eax,msg.wParam
		ret								

WinMain EndP

WndProc		PROC	hWnd:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD
	
	.if		uMsg==WM_DESTROY
		invoke	PostQuitMessage,NULL
	.elseif uMsg==WM_CREATE
		mov		edi,lParam
		.if		[edi.CREATESTRUCT].hWndParent==NULL
			invoke	GetClientRect,hWnd,addr rect
			invoke	CreateWindowEx,NULL,addr TreeViewClass,NULL,WS_VISIBLE+WS_CHILD+TVS_HASLINES+TVS_HASBUTTONS+TVS_LINESATROOT,\
									0,0,rect.right,rect.bottom,hWnd,NULL,hInstance,NULL
			mov		hTreeView,eax
			invoke	LoadImage,hInstance,addr szUnselArrow,IMAGE_BITMAP,20,20,LR_LOADFROMFILE
			mov		hUnselArrow,eax
			invoke	LoadImage,hInstance,addr szSelArrow,IMAGE_BITMAP,20,20,LR_LOADFROMFILE
			mov		hSelArrow,eax			
			call		FillTree
		.endif						
	.elseif	uMsg==WM_NOTIFY
		mov		edi,lParam
		.if	[edi.NMCUSTOMDRAW].hdr.code==NM_CUSTOMDRAW
			.if	[edi.NMCUSTOMDRAW].dwDrawStage==CDDS_PREPAINT
				mov		eax,CDRF_NOTIFYITEMDRAW
				ret
			.elseif 	[edi.NMCUSTOMDRAW].dwDrawStage==CDDS_ITEMPREPAINT
				invoke	CreateCompatibleDC,[edi.NMCUSTOMDRAW].hdc
				mov		hMemDC,eax
				mov		tvi.imask,TVIF_TEXT+TVIF_IMAGE+TVIF_HANDLE
				push		[edi.NMCUSTOMDRAW].dwItemSpec
				pop		tvi.hItem					
				mov		tvi.pszText,offset Buffer
				mov		tvi.cchTextMax,256
				invoke	SendMessage,hTreeView,TVM_GETITEM,NULL,addr tvi
				invoke	ImageList_Draw,hList,tvi.iImage,[edi.NMCUSTOMDRAW].hdc,[edi.NMCUSTOMDRAW].rc.left,[edi.NMCUSTOMDRAW].rc.top,ILD_NORMAL
				add		[edi.NMCUSTOMDRAW].rc.left,22
				add		[edi.NMCUSTOMDRAW].rc.right,22				
				.if		[edi.NMCUSTOMDRAW].uItemState&&CDIS_SELECTED
					invoke	SelectObject,hMemDC,hSelArrow
				.else
					invoke	SelectObject,hMemDC,hUnselArrow
				.endif
				invoke	StretchBlt,[edi.NMCUSTOMDRAW].hdc,[edi.NMCUSTOMDRAW].rc.left,[edi.NMCUSTOMDRAW].rc.top,20,20,hMemDC,\
									0,0,20,20,SRCCOPY
				add		[edi.NMCUSTOMDRAW].rc.left,22
				add		[edi.NMCUSTOMDRAW].rc.right,22																													
				invoke	CreateFont,16,8,NULL,NULL,FW_BOLD,TRUE,FALSE,FALSE,DEFAULT_CHARSET,OUT_CHARACTER_PRECIS,CLIP_CHARACTER_PRECIS,\
								PROOF_QUALITY,FIXED_PITCH+FF_MODERN,addr szTahoma
				invoke	SelectObject,[edi.NMCUSTOMDRAW].hdc,eax								
				invoke	DrawText,[edi.NMCUSTOMDRAW].hdc,tvi.pszText,-1,addr [edi.NMCUSTOMDRAW].rc,DT_LEFT
				invoke	DeleteDC,hMemDC						
 				mov		eax,CDRF_SKIPDEFAULT
				ret
			.endif														
																		
		.endif																					
	.else
		invoke	DefWindowProc,hWnd,uMsg,wParam,lParam
		ret
	.endif
	xor	eax,eax										
	Ret
WndProc EndP

FillTree	PROC
	
	invoke	SHGetFileInfo,addr szDirectory,NULL,addr shfi,sizeof shfi,SHGFI_SYSICONINDEX+SHGFI_SMALLICON
	mov		hList,eax
	invoke	SendMessage,hTreeView,TVM_SETIMAGELIST,TVSIL_NORMAL,eax
	push		shfi.iIcon
	pop		tvis.item.iImage
	invoke	SHGetFileInfo,addr szDirectory,NULL,addr shfi,sizeof shfi,SHGFI_SYSICONINDEX+SHGFI_OPENICON
	push		shfi.iIcon
	pop		tvis.item.iSelectedImage	
	mov		tvis.hParent,NULL
	mov		tvis.hInsertAfter,TVI_ROOT
	mov		tvis.item.imask,TVIF_TEXT+TVIF_IMAGE+TVIF_SELECTEDIMAGE
	mov		tvis.item.pszText,offset w32fd.cFileName
	invoke	FindFirstFile,addr szSpec,addr w32fd
	or		eax,eax
	jz		end_ftv
	mov		hFind,eax
compares:
	cmp		w32fd.cFileName,'.'
	je		find_next
	test		w32fd.dwFileAttributes,FILE_ATTRIBUTE_DIRECTORY
	jnz		do_it
find_next:
	invoke	FindNextFile,hFind,addr w32fd
	or		eax,eax
	jz		end_ftv
	jmp		compares
do_it:
	invoke	AddString,addr szSpec,addr w32fd.cFileName
	invoke	SendMessage,hTreeView,TVM_INSERTITEM,NULL,addr tvis
	jmp		find_next
end_ftv:																	
	Ret
FillTree EndP

AddString		PROC	lpDest:DWORD,lpSource:DWORD
	
	mov		esi,lpDest
	cld
align_loop:
	lodsb
	cmp		al,'\'
	jne		align_loop
	mov		edi,esi
	mov		esi,lpSource
add_loop:
	lodsb
	or		al,al
	jz		end_addloop
	stosb
	jmp		add_loop
end_addloop:
	stosb	
	Ret
	
AddString EndP

end	start
		